<?
require_once "../lib/dbinit.php";

class Notice {
    function Notice() {
    }

    /* override this in subclasses */
    function notify() {
    }

    /* emailNotify()
     * @access private
     */
    function emailNotify($from, $subj, $msg) {
        //In violation of the style used elsewhere, emailNotify makes
        //Its own db connections.
        require_once "../lib/Emailer.php";
        $e = new Emailer;

        //currently works with PodAuth using the DB storage class
        //XXX needs to change if you're using non-pod user db

        //can't use storage->db->getAll cause AuthContainer is dumb
//         $db = $podauth->storage;
        $db = dbinit_connect();
        $metadb = dbinit_meta_connect();

        $res = $db->query("SELECT username FROM users 
                            WHERE wants_email_posts = 1");
        $quoted_usernames = array();
        while($row = $res->fetchRow()) {
            $quoted_usernames[] = "'" .addslashes($row['username']) ."'";
        }

        $rows = Array();
        if($quoted_usernames) {
            $usernames_sql = "(" .implode(",", $quoted_usernames). ")";

            $res = $metadb->query(
                        "SELECT firstname,lastname,email FROM users
                            WHERE username IN $usernames_sql
                            AND email != \"\"");
            while($row = $res->fetchRow()) {
                $rows[] = $row;
            }
        }
        $nonuser_subscribers = $db->getAll("SELECT email FROM nonuser_subscribers");
        $e->setRecipientsFromRows($rows);
        $e->setNonuserRecipientsFromRows($nonuser_subscribers);
        $e->setSubject($subj);
        $e->setTextMessage($msg);
        if($from) {
            $e->setFrom($from);
        }
        $e->send();
    }

    /* Add new notification methods here - AIM, IRC, rss, or whatever*/

//XXX this might be good to bring back sometime

//     /* _logForDigest() - DEPRECATED
//      * @access private
//      */
//     function _logForDigest($logname, $logentry) {
//         $dailylog = fopen(POD_FILE_ROOT."/log/daily/$logname", 'a');
//         $weeklylog =fopen(POD_FILE_ROOT."/log/weekly/$logname", 'a');
//         $line = $logentry . "\n";
//         fwrite($dailylog, $line);
//         fwrite($weeklylog, $line);
//         fclose($dailylog);
//         fclose($weeklylog);
//     }

        
}

class MessageNotice extends Notice {
    function MessageNotice($authorUsername, $msg_id, $subj, $emailMsg) {
        $this->authorUsername = $authorUsername;
        $this->msg_id = $msg_id;
        $this->subj = $subj;
        $this->emailMsg = $emailMsg;
    }
    
    function notify() {
        $emailFrom = ""; //to use Emailer default
        $emailSubj = "$this->authorUsername: \"$this->subj\"";
        $emailMsg = $this->emailMsg;
        
        $this->emailNotify($emailFrom, $emailSubj, $emailMsg);
    }

}

class DocumentNotice extends Notice {
    function DocumentNotice(&$doc, $db) {
        $this->doc = $doc;
        $q = "SELECT long_name FROM mareas
              WHERE marea_id = $doc->marea_id";
        $this->marea_name = $db->getOne($q);
    }

    function notify() {
        $emailFrom = "";
        $emailSubj  = "New document \"".$this->doc->title."\"";
        $emailSubj .= " by ".$this->doc->orig_author;
        $emsg = $this->doc->display_tag . ". " . $this->doc->title . "\n\n";
	$emsg .= $this->doc->preface_text . "\n\n";
        $emsg .= "This new document posted by " . $this->doc->orig_author;
        $emsg .= " in the meeting area \"".$this->marea_name."\".\n\n";
        $emsg .= "View it at:  ";
        $emsg .= "  ".POD_URL_ROOT."/marea/?";
        $emsg .= "marea_id=".$this->doc->marea_id;
        $emsg .= "&msg_id=".$this->doc->orig_preface_msg_id;
        $this->emailNotify( $emailFrom, $emailSubj, $emsg);
    }
}
/*
class DiscoItemNotice extends Notice {
    function DiscoItemNotice($db,$marea_id,$title,$preface,$author,$msg_id) {
        $this->msg_id = $msg_id;
        $this->marea_name = $db->getOne("SELECT long_name FROM mareas WHERE
            marea_id = $marea_id");
        $this->author = $author;
        $this->title = $title;
	$this->preface = $preface;
        $this->marea_id = $marea_id;
    }

    function notify() {
        $emailFrom = "";
        $emailSubj  = "New discussion item \"".$this->title."\"";
        $emailSubj .= " by ".$this->author;
        
	$msg = $this->title . "\n\n";
	$msg .= $this->preface . "\n\n";
        $msg .= "This new discussion item posted by " . $this->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";

        $msg .= "View it at: ";
        $msg .= POD_URL_ROOT."/marea/?";
        $msg .= "marea_id=".$this->marea_id;
        $msg .= "&msg_id=".$this->msg_id;
        $this->emailNotify( $emailFrom, $emailSubj, $msg);
    }
}*/

class DiscoItemNotice extends Notice {
  function DiscoItemNotice($db, $discoitem) {
    $this->discoitem = $discoitem;
    $this->marea_name = $db->getOne("SELECT long_name FROM mareas 
                              WHERE marea_id = $discoitem->marea_id");
  }

  function notify() {
        $emailFrom = "";
        $emailSubj  = "New discussion item \"".$this->discoitem->title."\"";
        $emailSubj .= " by ".$this->discoitem->author;
        
	$msg = /*$this->discoitem->displaytag .*/ "New discussion item: " . $this->discoitem->title . "\n\n";
	$msg .= $this->discoitem->preface_text . "\n\n";
        $msg .= "This new discussion item posted by " . $this->discoitem->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";

        $msg .= "View it at: ";
        $msg .= POD_URL_ROOT."/marea/?";
        $msg .= "marea_id=".$this->discoitem->marea_id;
        $msg .= "&msg_id=".$this->discoitem->msg_id;
        $this->emailNotify( $emailFrom, $emailSubj, $msg);
    }
}
class ProjectNotice extends Notice {
  function ProjectNotice($db, $project) {
    $this->project = $project;
    $this->marea_name = $db->getOne("SELECT long_name FROM mareas 
                              WHERE marea_id = $project->marea_id");
  }

  function notify() {
        $emailFrom = "";
        $emailSubj  = "New Project\"".$this->project->title."\"";
        $emailSubj .= " by ".$this->project->author;
        
	$msg = /*$this->project->displaytag .*/ "New project: " . $this->project->title . "\n\n";
	$msg .= $this->project->preface_text . "\n\n";
        $msg .= "This new project was posted by " . $this->project->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";

        $msg .= "View it at: ";
        $msg .= POD_URL_ROOT."/marea/?";
        $msg .= "marea_id=".$this->project->marea_id;
        $msg .= "&msg_id=".$this->project->msg_id;
        $this->emailNotify( $emailFrom, $emailSubj, $msg);
    }
}

class TaskNotice extends Notice {
  function TaskNotice($db, $task) {
    $this->task = $task;
    $this->marea_name = $db->getOne("SELECT long_name FROM mareas 
                              WHERE marea_id = $task->marea_id");
  }

  function notify() {
        $emailFrom = "";
        $emailSubj  = "New Task\"".$this->task->title."\"";
        $emailSubj .= " by ".$this->task->author;
        
	$msg = /*$this->task->displaytag .*/ "New Task: " . $this->task->title . "\n\n";
	$msg .= $this->task->preface_text . "\n\n";
        $msg .= "This new task was posted by " . $this->task->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";
	$msg .= "Description: ".$this->task->description."\n\n";
	$msg .= "Priority Rating: ".$this->task->priority." | Category: " .$this->task->category."\n\n";
        $msg .= "View it at: ";
        $msg .= POD_URL_ROOT."/marea/?";
        $msg .= "marea_id=".$this->task->marea_id;
        $msg .= "&msg_id=".$this->task->msg_id;
        $this->emailNotify( $emailFrom, $emailSubj, $msg);
    }
}


    
/*
class LinkNotice extends Notice {
    function LinkNotice($db,$marea_id,$title,$preface,$link,$author,$msg_id) {
        $this->msg_id = $msg_id;
        $this->marea_name = $db->getOne("SELECT long_name FROM mareas WHERE
            marea_id = $marea_id");
        $this->author = $author;
        $this->title = $title;
	$this->preface = $preface;
	$this->link = $link;
        $this->marea_id = $marea_id;
    }

    function notify() {
        $emailFrom = "";
        $emailSubj  = "New link \"".$this->title."\"";
        $emailSubj .= " by ".$this->author;
	
	$msg = $this->title . "\n\n";
	$msg .= $this->preface . "\n\n";
	$msg .= "Link: " . $this->link . "\n\n";
        $msg .= "This new discussion item posted by " . $this->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";
        $msg .= "View it at:  ";
        $msg .= POD_URL_ROOT."/marea/?";
        $msg .= "marea_id=".$this->marea_id;
        $msg .= "&msg_id=".$this->msg_id;
        $this->emailNotify( $emailFrom, $emailSubj, $msg);
    }
}*/

class LinkNotice extends Notice {
  function LinkNotice($db, $link) {
    $this->link = $link;
    $this->marea_name = $db->getOne("SELECT long_name FROM mareas WHERE
            marea_id = $link->marea_id");
  }

    function notify() {
        $emailFrom = "";
        $emailSubj  = "New link \"".$this->link->title."\"";
        $emailSubj .= " by ".$this->link->author;
	
	$msg = $this->link->display_tag . ". " . $this->link->title . "\n\n";
	$msg .= $this->link->preface_text . "\n\n";
	$msg .= "Link: " . $this->link->link . "\n\n";
        $msg .= "This new link was posted by " . $this->link->author;
        $msg .= " in the meeting area \"".$this->marea_name."\".\n\n";
        $msg .= "View it at:  ";
        $msg .= POD_URL_ROOT."/marea/?";
        $msg .= "marea_id=".$this->link->marea_id;
        $msg .= "&msg_id=".$this->link->msg_id;
        $this->emailNotify( $emailFrom, $emailSubj, $msg);
    }
}

class MeetingAreaNotice extends Notice {
    function MeetingAreaNotice($name, $creator, $marea_id) {
        $this->name = $name;
        $this->creator = $creator;
        $this->marea_id = $marea_id;
    }
    function notify() {
        $emailSubj  = "New meeting area \"".$this->name."\"";
        $emailSubj .= " by ".$this->creator;

        $emsg  = $this->creator." has created the meeting area ";
        $emsg .= "\"".$this->name."\".\n\n";
        $emsg .= "View at:\n";
        $emsg .= "  ".POD_URL_ROOT."/marea/?marea_id=".$this->marea_id;

        $this->emailNotify("", $emailSubj, $emsg);
    }
}

    
class AnnounceCloseNotice extends Notice {
    function notify( $subj, $body) {
        $this->emailNotify("", $subj, $body);
    }
}


class PollNotice extends Notice {
    function PollNotice($poll, $db) {
        $this->poll = $poll;
        $q = "SELECT long_name FROM mareas
              WHERE marea_id = ".$this->poll->marea_id;
        $this->marea_name = $db->getOne($q);
    }

    function notify() {
        $emailFrom = "";
        $emailSubj  = "New Poll \"".$this->poll->title."\"";
        $emailSubj .= " created by ".$this->poll->author;
	
	$emsg = $this->poll->display_tag . ". " . $this->poll->title . "\n\n";
        $emsg .= $this->poll->author ." has created a new poll ";
        $emsg .= "in the meeting area \"".$this->marea_name."\".\n";
        $emsg .= "View at: ";
        $emsg .= POD_URL_ROOT."/marea/?";
        $emsg .= "marea_id=".$this->poll->marea_id;
        $emsg .= "&obj_id=".$this->poll->poll_id;
        $emsg .= "&obj_type=poll";
        $this->emailNotify( $emailFrom, $emailSubj, $emsg);
    }
}
